local crates = {
	{"images/crate.png", "images/crate.png", "images/crate.png", "images/crate.png"},
	{"images/crate_locked.png", "images/crate_locked.png", "images/crate_locked.png", "images/crate_locked.png"},
	{"images/crate.png", "images/crate.png", "images/crate.png", "images/crate.png"},
	{"images/crate_locked.png", "images/crate_locked.png", "images/crate_locked.png", "images/crate_locked.png"}
}

local scenes = {}

currentScene = 1

for i in pairs(crates) do
	local scene = gideros.class(Sprite)
	function scene:init()
		AceSlide.init({parent = self})
		for j in pairs(crates[i]) do
			AceSlide.add(Bitmap.new(Texture.new(crates[i][j], true)))
		end
		AceSlide.show()
		
		
		local leftButton = Button.new(Bitmap.new(Texture.new("images/left-up.png")), Bitmap.new(Texture.new("images/left-down.png")))
		leftButton:setPosition((application:getContentWidth()-leftButton:getWidth())/5, (application:getContentHeight()/2)-(leftButton:getHeight()/2))
		self:addChild(leftButton)
		leftButton:addEventListener("click", 
			function()	
				AceSlide.prevItem()
			end
		)
	
		local rightButton = Button.new(Bitmap.new(Texture.new("images/right-up.png")), Bitmap.new(Texture.new("images/right-down.png")))
		rightButton:setPosition(((application:getContentWidth()-rightButton:getWidth())/5)*4, (application:getContentHeight()/2)-(rightButton:getHeight()/2))
		self:addChild(rightButton)
		rightButton:addEventListener("click", 
			function()	
				AceSlide.nextItem()
			end
		)
		
		local upButton = Button.new(Bitmap.new(Texture.new("images/up-up.png")), Bitmap.new(Texture.new("images/up-down.png")))
		upButton:setPosition((application:getContentWidth()-upButton:getWidth())/2, (application:getContentHeight()-upButton:getHeight())/5)
		self:addChild(upButton)
		upButton:addEventListener("click", 
			function()	
				if currentScene > 1 then
					currentScene = currentScene - 1
					sceneManager:changeScene("scene"..currentScene, 1, SceneManager.moveFromTop, easing.outBack)
				end
			end
		)
	
		local downButton = Button.new(Bitmap.new(Texture.new("images/down-up.png")), Bitmap.new(Texture.new("images/down-down.png")))
		downButton:setPosition((application:getContentWidth()-downButton:getWidth())/2, ((application:getContentHeight()-upButton:getHeight())/5)*4)
		self:addChild(downButton)
		downButton:addEventListener("click", 
			function()	
				if currentScene < #crates then
					currentScene = currentScene + 1
					sceneManager:changeScene("scene"..currentScene, 1, SceneManager.moveFromBottom, easing.outBack)
				end
			end
		)
		
		local function onMouseDown(self, event)
			if self:hitTestPoint(event.x, event.y) then
				self.isFocus = true
				self.startY = event.y
				self.initY = self:getY()
				self.y0 = event.y
		
				event:stopPropagation()
			end
		end
		
		local function onMouseMove(self, event)
			if self.isFocus then
				local dy = event.y - self.y0
				
				self:setY(self:getY() + dy)
		
				self.y0 = event.y
		
				event:stopPropagation()
			end
		end
		
		local function onMouseUp(self, event)
			if self.isFocus then
				local back = false
				if self.startY < self.y0 - 10 then
					if currentScene > 1 then
						currentScene = currentScene - 1
						sceneManager:changeScene("scene"..currentScene, 1, SceneManager.moveFromTop, easing.outBack)
					else
						back = true
					end
				elseif self.startY > self.y0 + 10 then
					if currentScene < #crates then
						currentScene = currentScene + 1
						sceneManager:changeScene("scene"..currentScene, 1, SceneManager.moveFromBottom, easing.outBack)
					else
						back = true
					end
				else
					back = true
				end
				if back then
					GTween.new(self, 1, {y = self.initY})
				end
				self.isFocus = false
				event:stopPropagation()
			end
		end
		
		self:addEventListener(Event.MOUSE_DOWN, onMouseDown, self)
		self:addEventListener(Event.MOUSE_MOVE, onMouseMove, self)
		self:addEventListener(Event.MOUSE_UP, onMouseUp, self)
	end
	scenes["scene"..i] = scene
end


sceneManager = SceneManager.new(scenes)

stage:addChild(sceneManager)

sceneManager:changeScene("scene"..currentScene, 1, SceneManager.flipWithFade, easing.outBack)